DOM::Element Class Reference

`#include <dom_element.h>`

Inheritance diagram for DOM::Element:

## Public Member Functions

| Element (const Node &other)
| Element (const Element &other)
Element & | operator= (const Node &other)
Element & | operator= (const Element &other)
DOMString | tagName () const
DOMString | getAttribute (const DOMString &name)
void | setAttribute (const DOMString &name, const DOMString &value)
void | removeAttribute (const DOMString &name)
Attr | getAttributeNode (const DOMString &name)
Attr | setAttributeNode (const Attr &newAttr)
Attr | removeAttributeNode (const Attr &oldAttr)
NodeList | getElementsByTagName (const DOMString &name)
NodeList | getElementsByTagNameNS (const DOMString &namespaceURI, const DOMString &localName)
DOMString | getAttributeNS (const DOMString &namespaceURI, const DOMString &localName)
void | setAttributeNS (const DOMString &namespaceURI, const DOMString &qualifiedName, const DOMString &value)
void | removeAttributeNS (const DOMString &namespaceURI, const DOMString &localName)
Attr | getAttributeNodeNS (const DOMString &namespaceURI, const DOMString &localName)
Attr | setAttributeNodeNS (const Attr &newAttr)
bool | hasAttribute (const DOMString &name)
bool | hasAttributeNS (const DOMString &namespaceURI, const DOMString &localName)
CSSStyleDeclaration | style ()
bool | contentEditable () const
void | setContentEditable (bool enabled)
bool | isHTMLElement () const
Element | form () const
Public Member Functions inherited from DOM::Node
| Node (const Node &other)
| Node (NodeImpl *_impl)
Node & | operator= (const Node &other)
bool | operator== (const Node &other) const
bool | operator!= (const Node &other) const
DOMString | nodeName () const
DOMString | nodeValue () const
void | setNodeValue (const DOMString &)
unsigned short | nodeType () const
Node | parentNode () const
NodeList | childNodes () const
Node | firstChild () const
Node | lastChild () const
Node | previousSibling () const
Node | nextSibling () const
NamedNodeMap | attributes () const
Document | ownerDocument () const
Node | insertBefore (const Node &newChild, const Node &refChild)
Node | replaceChild (const Node &newChild, const Node &oldChild)
Node | removeChild (const Node &oldChild)
Node | appendChild (const Node &newChild)
bool | hasChildNodes ()
Node | cloneNode (bool deep)
void | normalize ()
bool | isSupported (const DOMString &feature, const DOMString &version) const
DOMString | namespaceURI () const
DOMString | prefix () const
void | setPrefix (const DOMString &prefix)
DOMString | localName () const
bool | hasAttributes ()
DOMString | textContent () const
void | setTextContent (const DOMString &content) const
void | addEventListener (const DOMString &type, EventListener *listener, const bool useCapture)
void | removeEventListener (const DOMString &type, EventListener *listener, bool useCapture)
bool | dispatchEvent (const Event &evt)
Q_UINT32 | elementId () const
bool | isNull () const
NodeImpl * | handle () const
unsigned long | index () const
QString | toHTML () KDE_DEPRECATED
void | applyChanges ()
void | getCursor (int offset, int &_x, int &_y, int &height) KDE_DEPRECATED
QRect | getRect ()

## Static Public Member Functions

static bool | khtmlValidAttrName (const DOMString &name)
static bool | khtmlValidPrefix (const DOMString &name)
static bool | khtmlValidQualifiedName (const DOMString &name)
static bool | khtmlMalformedQualifiedName (const DOMString &name)
static bool | khtmlMalformedPrefix (const DOMString &name)

## Protected Member Functions

| Element (ElementImpl *_impl)

## Friends

class | Document
class | HTMLDocument
class | Attr

## Additional Inherited Members

Public Types inherited from DOM::Node
enum | NodeType { ELEMENT_NODE = 1, ATTRIBUTE_NODE = 2, TEXT_NODE = 3, CDATA_SECTION_NODE = 4, ENTITY_REFERENCE_NODE = 5, ENTITY_NODE = 6, PROCESSING_INSTRUCTION_NODE = 7, COMMENT_NODE = 8, DOCUMENT_NODE = 9, DOCUMENT_TYPE_NODE = 10, DOCUMENT_FRAGMENT_NODE = 11, NOTATION_NODE = 12 }
Protected Attributes inherited from DOM::Node
NodeImpl * | impl

## Detailed Description

By far the vast majority of objects (apart from text) that authors encounter when traversing a document are `Element` nodes.

Assume the following XML document: <elementExample id="demo"> <subelement1/> <subelement2><subsubelement/></subelement2> </elementExample>

When represented using DOM, the top node is an `Element` node for "elementExample", which contains two child `Element` nodes, one for "subelement1" and one for "subelement2". "subelement1" contains no child nodes.

Elements may have attributes associated with them; since the `Element` interface inherits from `Node` , the generic `Node` interface method `getAttributes` may be used to retrieve the set of all attributes for an element. There are methods on the `Element` interface to retrieve either an `Attr` object by name or an attribute value by name. In XML, where an attribute value may contain entity references, an `Attr` object should be retrieved to examine the possibly fairly complex sub-tree representing the attribute value. On the other hand, in HTML, where all attributes have simple string values, methods to directly access an attribute value can safely be used as a convenience.

Definition at line 210 of file dom_element.h.

## Member Function Documentation

bool Element::contentEditable | ( |  | ) | const

not part of the official DOM

This method will always reflect the editability setting of this element as specified by a direct or indirect (that means, inherited) assignment to contentEditable or the respective CSS rule, even if design mode is active.

Returns
  whether this element is editable.

Since
  3.2

See also
  setContentEditable

Definition at line 355 of file dom_element.cpp.

Element Element::form | ( |  | ) | const

KHTML extension to DOM This method returns the associated form element.

returns null if this element is not a form-like element or if this elment is not in the scope of a form element.

Definition at line 338 of file dom_element.cpp.

DOMString Element::getAttribute | ( | const DOMString & | name | ) |

Retrieves an attribute value by name.

Parameters

  name | The name of the attribute to retrieve.

Returns
  The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value.

Definition at line 147 of file dom_element.cpp.

Attr Element::getAttributeNode | ( | const DOMString & | name | ) |

Retrieves an `Attr` node by name.

Parameters

  name | The name of the attribute to retrieve.

Returns
  The `Attr` node with the specified attribute name or `null` if there is no such attribute.

Definition at line 188 of file dom_element.cpp.

Attr Element::getAttributeNodeNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | localName
| ) |  |

Introduced in DOM Level 2.

Retrieves an Attr node by local name and namespace URI. HTML-only DOM implementations do not need to implement this method.

Parameters

  namespaceURI | The namespace URI of the attribute to retrieve.
  localName | The local name of the attribute to retrieve.

Returns
  The Attr node with the specified attribute local name and namespace URI or null if there is no such attribute.

Definition at line 284 of file dom_element.cpp.

DOMString Element::getAttributeNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | localName
| ) |  |

Introduced in DOM Level 2.

No Exceptions.

Retrieves an attribute value by local name and namespace URI. HTML-only DOM implementations do not need to implement this method.

Parameters

  namespaceURI | The namespace URI of the attribute to retrieve.
  localName | The local name of the attribute to retrieve.

Returns
  The Attr value as a string, or the empty string if that attribute does not have a specified or default value.

Definition at line 249 of file dom_element.cpp.

NodeList Element::getElementsByTagName | ( | const DOMString & | name | ) |

Returns a `NodeList` of all descendant elements with a given tag name, in the order in which they would be encountered in a preorder traversal of the `Element` tree.

Parameters

  name | The name of the tag to match on. The special value "*" matches all tags.

Returns
  A list of matching `Element` nodes.

Definition at line 231 of file dom_element.cpp.

NodeList Element::getElementsByTagNameNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | localName
| ) |  |

Introduced in DOM Level 2 Returns a NodeList of all the descendant Elements with a given local name and namespace URI in the order in which they are encountered in a preorder traversal of this Element tree.

Parameters

  namespaceURI | The namespace URI of the elements to match on. The special value "*" matches all namespaces.
  localName | The local name of the elements to match on. The special value "*" matches all local names.

Returns
  A new NodeList object containing all the matched Elements.

Definition at line 242 of file dom_element.cpp.

bool Element::hasAttribute | ( | const DOMString & | name | ) |

Returns true when an attribute with a given name is specified on this element or has a default value, false otherwise.

Introduced in DOM Level 2.

Parameters

  name | The name of the attribute to look for.

Returns
  true if an attribute with the given name is specified on this element or has a default value, false otherwise.

Definition at line 312 of file dom_element.cpp.

bool Element::hasAttributeNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | localName
| ) |  |

Introduced in DOM Level 2.

Returns true when an attribute with a given local name and namespace URI is specified on this element or has a default value, false otherwise. HTML-only DOM implementations do not need to implement this method.

Parameters

  namespaceURI | The namespace URI of the attribute to look for.
  localName | The local name of the attribute to look for.

Returns
  true if an attribute with the given local name and namespace URI is specified or has a default value on this element, false otherwise.

Definition at line 322 of file dom_element.cpp.

void Element::removeAttribute | ( | const DOMString & | name | ) |

Removes an attribute by name.

If the removed attribute has a default value it is immediately replaced.

Parameters

  name | The name of the attribute to remove.

Returns

Exceptions

  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Definition at line 174 of file dom_element.cpp.

Attr Element::removeAttributeNode | ( | const Attr & | oldAttr | ) |

Removes the specified attribute.

Parameters

  oldAttr | The `Attr` node to remove from the attribute list. If the removed `Attr` has a default value it is immediately replaced.

Returns
  The `Attr` node that was removed.

Exceptions

  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NOT_FOUND_ERR: Raised if `oldAttr` is not an attribute of the element.

Definition at line 216 of file dom_element.cpp.

void Element::removeAttributeNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | localName
| ) |  |

Introduced in DOM Level 2.

Removes an attribute by local name and namespace URI. If the removed attribute has a default value it is immediately replaced. The replacing attribute has the same namespace URI and local name, as well as the original prefix.

HTML-only DOM implementations do not need to implement this method.

Parameters

  namespaceURI | The namespace URI of the attribute to remove.
  localName | The local name of the attribute to remove.

Exceptions

  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Definition at line 271 of file dom_element.cpp.

void Element::setAttribute | ( | const DOMString & | name,
|  | const DOMString & | value
| ) |  |

Adds a new attribute.

If an attribute with that name is already present in the element, its value is changed to be that of the value parameter. This value is a simple string, it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `Attr` node plus any `Text` and `EntityReference` nodes, build the appropriate subtree, and use `setAttributeNode` to assign it as the value of an attribute.

Parameters

  name | The name of the attribute to create or alter.
  value | Value to set in string form.

Returns

Exceptions

  DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an invalid character.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Definition at line 162 of file dom_element.cpp.

Attr Element::setAttributeNode | ( | const Attr & | newAttr | ) |

Adds a new attribute.

If an attribute with that name is already present in the element, it is replaced by the new one.

Parameters

  newAttr | The `Attr` node to add to the attribute list.

Returns
  If the `newAttr` attribute replaces an existing attribute with the same name, the previously existing `Attr` node is returned, otherwise `null` is returned.

Exceptions

  DOMException | WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.

Definition at line 201 of file dom_element.cpp.

Attr Element::setAttributeNodeNS | ( | const Attr & | newAttr | ) |

Introduced in DOM Level 2.

Adds a new attribute. If an attribute with that local name and that namespace URI is already present in the element, it is replaced by the new one.

HTML-only DOM implementations do not need to implement this method.

Parameters

  newAttr | The Attr node to add to the attribute list.

Returns
  If the newAttr attribute replaces an existing attribute with the same local name and namespace URI, the replaced Attr node is returned, otherwise null is returned.

Exceptions

  DOMException | WRONG_DOCUMENT_ERR: Raised if newAttr was created from a different document than the one that created the element.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

INUSE_ATTRIBUTE_ERR: Raised if newAttr is already an attribute of another Element object. The DOM user must explicitly clone Attr nodes to re-use them in other elements.

Definition at line 297 of file dom_element.cpp.

void Element::setAttributeNS | ( | const DOMString & | namespaceURI,
|  | const DOMString & | qualifiedName,
|  | const DOMString & | value
| ) |  |

Introduced in DOM Level 2.

Adds a new attribute. If an attribute with the same local name and namespace URI is already present on the element, its prefix is changed to be the prefix part of the qualifiedName, and its value is changed to be the value parameter. This value is a simple string; it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an Attr node plus any Text and EntityReference nodes, build the appropriate subtree, and use setAttributeNodeNS or setAttributeNode to assign it as the value of an attribute.

HTML-only DOM implementations do not need to implement this method.

Parameters

  namespaceURI | The namespace URI of the attribute to create or alter.
  qualifiedName | The qualified name of the attribute to create or alter.
  value | The value to set in string form.

Exceptions

  DOMException | INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character.

NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

NAMESPACE_ERR: Raised if the qualifiedName is malformed, if the qualifiedName has a prefix and the namespaceURI is null, if the qualifiedName has a prefix that is "xml" and the namespaceURI is different from "http://www.w3.org/XML/1998/namespace", or if the qualifiedName is "xmlns" and the namespaceURI is different from "http://www.w3.org/2000/xmlns/".

Definition at line 259 of file dom_element.cpp.

void Element::setContentEditable | ( | bool | enabled | ) |

not part of the official DOM

This element can be made editable by setting its contentEditable property to `true`. The setting will be inherited to its children as well.

Setting or clearing contentEditable when design mode is active will take no effect. However, its status will still be propagated to all child elements.

Parameters

  enabled | `true` to make this element editable, `false` otherwise.

See also
  DOM::Document::designMode

Since
  3.2

Definition at line 360 of file dom_element.cpp.

CSSStyleDeclaration Element::style | ( |  | ) |

Introduced in DOM Level 2 This method is from the CSSStyleDeclaration interface.

The style attribute

Definition at line 349 of file dom_element.cpp.

DOMString Element::tagName | ( |  | ) | const

The name of the element.

For example, in: <elementExample id="demo"> ... </elementExample> , `tagName` has the value `"elementExample"` . Note that this is case-preserving in XML, as are all of the operations of the DOM. The HTML DOM returns the `tagName` of an HTML element in the canonical uppercase form, regardless of the case in the source HTML document.

Definition at line 141 of file dom_element.cpp.

The documentation for this class was generated from the following files:

- dom_element.h
- dom_element.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys